package tis4.auth;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.CharBuffer;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.apache.catalina.websocket.MessageInbound;

public class WSInbound extends MessageInbound{
	private HttpServletRequest request;
	private HttpSession session;
	private boolean loggedin = false;
	private String username = "";
	public WSInbound(HttpServletRequest req){
		request = req;
		session = request.getSession(true);
		if(session.getAttribute("loggedin")!=null){
			loggedin = (boolean)session.getAttribute("loggedin");
		}
		if(session.getAttribute("user")!=null){
			username = (String)session.getAttribute("user");
		}
	}
	@Override
	protected void onBinaryMessage(ByteBuffer arg0) throws IOException {
		System.out.println("binary message received - ignoring");
	}

	@Override
	protected void onTextMessage(CharBuffer arg0) throws IOException {
		String msg = arg0.toString();
		if(!loggedin){
			if(msg.contains("-")){
				String[] split = msg.split("-");
				if(split.length==3){
					if(split[0].equals("login")&&authenticate(split[1],split[2])){
						session.setAttribute("loggedin", true);
						session.setAttribute("user", split[1]);
						loggedin = (boolean)session.getAttribute("loggedin");
						username = (String)session.getAttribute("user");
						this.getWsOutbound().writeTextMessage(CharBuffer.wrap("true"));
					}else{
						this.getWsOutbound().writeTextMessage(CharBuffer.wrap("false"));
					}
				}
			}
		}else if(msg.equals("logout")){
			session.setAttribute("loggedin", false);
			session.setAttribute("user", "");
			loggedin = (boolean)session.getAttribute("loggedin");
			username = (String)session.getAttribute("user");
		}else if(msg.equals("hello")&&loggedin){
			try {
				this.getWsOutbound().writeTextMessage(CharBuffer.wrap("true"));
			} catch (IOException e) {
				e.printStackTrace();
			}
		}else{
			if(msg.equals("ping")){
				this.getWsOutbound().writeTextMessage(CharBuffer.wrap("pong"));
			}
		}
	}
	private boolean authenticate(String username, String password){
		if(username.equals("admin")&&password.equals("admin")){
			return true;
		}
		return false;
	}
	@Override
	protected void onClose(int status){
		session.setAttribute("loggedin",false);
	}

}
